import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.BorderLayout;
import java.awt.Canvas;

/**
 * Opens a window entitled "My example program".
 * In this version, I've changed the generic Canvas to a MyCanvas so I can actually
 * draw something in it.
 * @version 19, 15 Feb 2005.
 **/
public class Example 
{
    private JTextField input = new JTextField ("Please type something here.");
    private Canvas picture = new MyCanvas ();
    private void setUpWindow () {
        // Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);
        
        // Create the window and set its size.
        JFrame frame = new JFrame ("My example program");
        
        // Make sure the program exits when the window is closed.
        frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
        
        // Create the buttons...
        JButton copyButton = new JButton ("copy");
        JButton clearButton = new JButton ("clear");
        JButton quitButton = new JButton ("quit");
        
        // Create the panel they live in, and add them to it.
        JPanel buttons = new JPanel ();
        buttons.add (copyButton);
        buttons.add (clearButton);
        buttons.add (quitButton);
        // Note that by default, a JPanel uses FlowLayout, so the buttons are
        // added from left to right.
        
        // Now add the Canvas, the button panel, and the input field to the JFrame.
        frame.getContentPane().add(this.picture, BorderLayout.CENTER);
        frame.getContentPane().add(buttons, BorderLayout.NORTH);
        frame.getContentPane().add(this.input, BorderLayout.SOUTH);
        
        // Tell each button what it does.
        copyButton.addActionListener (new ActionListener () {
            public void actionPerformed (ActionEvent e) {
                // do nothing
            }});
        clearButton.addActionListener (new ActionListener () {
            public void actionPerformed (ActionEvent e) {
                // do nothing
            }});
        quitButton.addActionListener (new ActionListener () {
            public void actionPerformed (ActionEvent e) {
                System.exit(0);
            }});
        
        // Compute the size of the window, just big enough to hold the labels.
        frame.pack();
        
        // Show the window.
        frame.setVisible(true);
        }
        
    public static void main(String[] args) {
        final Example theExample = new Example();
        javax.swing.SwingUtilities.invokeLater (new Runnable () {
            public void run () {
                theExample.setUpWindow();
            }
        });
    }
}
